`timescale 1ns / 1ps

//******************************************************************************
//* 4-digit seven-segment display driver module.                               *
//******************************************************************************
module SevenSegmentDisplay(
   //Clock and reset.
   input  wire       clk,     //System clock
   input  wire       rst,     //Reset signal
   
   //Input data.
   input  wire [3:0] dig0,    //Value displayed on DIG0
   input  wire [3:0] dig1,    //Value displayed on DIG1
   input  wire [3:0] dig2,    //Value displayed on DIG2
   input  wire [3:0] dig3,    //Value displayed on DIG3
   
   //Signals driving the seven-segment display.
   output wire [7:0] seg_n,   //Segment control signal (active-low)
   output reg  [3:0] dig_n    //Digit select signal (active-low)
);

//******************************************************************************
//* FSM that generates the repeating 00, 01, 10, 11,... sequence for selecting *
//* one digit of the seven-segment display.                                    *
//******************************************************************************
//Declare 4 local parameters here that represent the states of the FSM.
//Assign unique values to each state, use minimum bit-width encoding!
localparam STATE_DIG0 = ;

//Declare the dig_state state register here with the proper size!
reg ...

//Implement the FSM in an always block. Sequential logic is described here
//so use the non-blocking assignment operator (<=). If the system reset
//signal is active, set the initial state. Else, using the case instruction,
//set the next state. The FSM has no input, therefore a single assignment is
//required for each alternative in the case instruction.
always @(posedge clk)
begin
   if (rst)
      //Set the initial state if the system reset is active.
   else
      case ()
         //Set the next state here.
      endcase
end


//******************************************************************************
//* Input data select multiplexer.                                             *
//******************************************************************************
//Output of the input data select multiplexer.
reg [3:0] dig_mux;

//Implement the input data select multiplexer in this always block. For each
//state of the FSM, select the proper input data (dig0-dig3). Use the case
//instruction. This is a combinational logic, so use the blocking assignment
//operator (=).
always @(*)
begin

end


//******************************************************************************
//* Hexadecimal to seven-segment decoder.                                      *
//******************************************************************************
//Signal connected to the output of the seven-segment decoder.
wire [7:0] seg_data;

//Instantiate the seven-segment decoder module here!

//Drive the segment control signal with the output of the decoder.
//This signal is active-low, the output of the decoder is active-high.
assign seg_n = ;


//******************************************************************************
//* 2-to-4 decoder (active-low outptut) for generating the digit select signal.*
//******************************************************************************
//Implement the 2-to-4 decoder with active-low output in an always block that
//generates the digit select signal. The output of the decoder is the dig_n
//signal. Use the case instruction. This is a combinational logic, so use the
//blocking assignment operator (=).


endmodule
